forgot password?


   
 
Sys-V init script for Debian
Posted: 09 November 2011 03:54 PM   [ Ignore ]  
Newbie
Avatar
Rank
Total Posts:  2
Joined  2009-08-04

Can’t take much credit for this, but here’s an init.d script I cobbled together to get Tracks started on a Debian server.  By way of background, Tracks is installed at /var/www/tracks and proxied through Apache.

#! /bin/sh
### BEGIN INIT INFO
# Provides:          tracks
# Required-Start:    $remote_fs $syslog
# Required-Stop:     $remote_fs $syslog
# Default-Start:     3 4 5
# Default-Stop:      0 1 2 6
# Short-Description: Standalone tracks web server
# Description: Tracks is a web-based GTD application.
### END INIT INFO

PATH=/sbin:/bin:/usr/local/sbin:/usr/local/bin:/sbin:/bin:/usr/sbin:/usr/bin
DESC
="Tracks standalone web server"
NAME=server
DAEMON
=/var/www/tracks/script/$NAME
DAEMON_ARGS
="--daemon --environment=production"
PIDFILE=/var/run/tracks.pid
SCRIPTNAME
=/etc/init.d/tracks

# Exit if the package is not installed
-"$DAEMON|| exit 0

# Load the VERBOSE setting and other rcS variables
. /lib/init/vars.sh

# Define LSB log_* functions.
# Depend on lsb-base (>= 3.2-14) to ensure that this file is present
# and status_of_proc is working.
. /lib/lsb/init-functions

#
# Function that starts the daemon/service
#
do_start()
{
        
# Return
        #   0 if daemon has been started
        #   1 if daemon was already running
        #   2 if daemon could not be started
        
start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON --test > /dev/null \
                
|| return 1
        start
-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON -- \
                $DAEMON_ARGS \
                
|| return 2
        
# Add code here, if necessary, that waits for the process to be ready
        # to handle requests from services started subsequently which depend
        # on this one.  As a last resort, sleep for some time.
}

#
# Function that stops the daemon/service
#
do_stop()
{
        
# Return
        #   0 if daemon has been stopped
        #   1 if daemon was already stopped
        #   2 if daemon could not be stopped
        #   other if a failure occurred
        
start-stop-daemon --stop --quiet --retry=TERM/30/KILL/--pidfile $PIDFILE --name $NAME
        RETVAL
="$?"
        
"$RETVAL2 ] && return 2
        
# Wait for children to finish too if this is a daemon that forks
        # and if the daemon is only ever run from this initscript.
        # If the above conditions are not satisfied then add some other code
        # that waits for the process to drop all resources that could be
        # needed by services started subsequently.  A last resort is to
        # sleep for some time.
        
start-stop-daemon --stop --quiet --oknodo --retry=0/30/KILL/--exec $DAEMON
        [ 
"$?" 2 ] && return 2
        
# Many daemons don't delete their pidfiles when they exit.
        
rm -f $PIDFILE
        
return "$RETVAL"
}

#
# Function that sends a SIGHUP to the daemon/service
#
do_reload() {
        
#
        # If the daemon can reload its configuration without
        # restarting (for example, when it is sent a SIGHUP),
        # then implement that here.
        #
        
start-stop-daemon --stop --signal 1 --quiet --pidfile $PIDFILE --name $NAME
        
return 0
}

case "$1" in
  start
)
        
"$VERBOSE!= no ] && log_daemon_msg "Starting $DESC" "$NAME"
        
do_start
        
case "$?" in
                0
|1"$VERBOSE!= no ] && log_end_msg 0 ;;
                
2"$VERBOSE!= no ] && log_end_msg 1 ;;
        
esac
        
;;
  
stop)
        
"$VERBOSE!= no ] && log_daemon_msg "Stopping $DESC" "$NAME"
        
do_stop
        
case "$?" in
                0
|1"$VERBOSE!= no ] && log_end_msg 0 ;;
                
2"$VERBOSE!= no ] && log_end_msg 1 ;;
        
esac
        
;;
  
status)
       
status_of_proc "$DAEMON" "$NAME&& exit || exit $?
       ;;
  
#reload|force-reload)
        #
        # If do_reload() is not implemented then leave this commented out
        # and leave 'force-reload' as an alias for 'restart'.
        #
        #log_daemon_msg "Reloading $DESC" "$NAME"
        #do_reload
        #log_end_msg $?
        #;;
  
restart|force-reload)
        
#
        # If the "reload" option is implemented then remove the
        # 'force-reload' alias
        #
        
log_daemon_msg "Restarting $DESC" "$NAME"
        
do_stop
        
case "$?" in
          0
|1)
                
do_start
                
case "$?" in
                        0
log_end_msg 0 ;;
                        
1log_end_msg 1 ;; # Old process is still running
                        
*) log_end_msg 1 ;; # Failed to start
                
esac
                
;;
          *)
                
# Failed to stop
                
log_end_msg 1
                
;;
        
esac
        
;;
  *)
        
#echo "Usage: $SCRIPTNAME {start|stop|restart|reload|force-reload}" >&2
        
echo "Usage: $SCRIPTNAME {start|stop|status|restart|force-reload}" >&2
        
exit 3
        
;;
esac

 Signature 

Author of the fantasy thriller, Insensate - available for all ebook readers and iDevices. Find out more >here<. Only 99p/99¢!

Profile
 
 
Posted: 09 November 2011 03:57 PM   [ Ignore ]   [ # 1 ]  
Newbie
Avatar
Rank
Total Posts:  2
Joined  2009-08-04

And again, in case it’s of some use, I’ve added the following Apache site; you’ll need to enable the Apache proxy module AND the Apache proxy_http module:

<VirtualHost *:80>
  
ServerName my.domain
  DocumentRoot 
/var/www/tracks/public
  
ErrorLog /var/www/tracks/log/tracks_error_log
  CustomLog 
/var/www/tracks/log/tracks_access_log combined
  ProxyRequests Off
  
<Proxy *>
    
Order deny,allow
    Allow from all
  
</Proxy>
  
ProxyPass http://127.0.0.1:3000/
  
ProxyPassReverse http://127.0.0.1:3000/
  
ProxyPreserveHost On

</VirtualHost
 Signature 

Author of the fantasy thriller, Insensate - available for all ebook readers and iDevices. Find out more >here<. Only 99p/99¢!

Profile